#include <pollard-rho.h>
#include <random.h>
#include <module.h>
#include <euclide.h>

giantint FindFactor(giantint n)
{
  giantint x = RandomRange((giantint)2, (giantint)(n - 1));
  giantint y = x;
  unsigned int k = 2;
  
  unsigned int i;
  for (i = 0; i < 10000; i++)
  {
    x = Module(x * x - 1, n);
    if (x < 0) x += n;
    giantint d = Gcd(y - x, n);
    if ((d != 1) && (d != n)) return d;
    if (i == k)
    {
      y = x;
      k *= 2;
    }
  }
  return 1;
}

